package com.sundot.airport.system.service.portrait;

import com.sundot.airport.common.domain.portrait.BaseModuleIndicatorResult;
import com.sundot.airport.common.domain.portrait.IndicatorCalculateParams;
import com.sundot.airport.common.enums.portrait.IndicatorType;
import com.sundot.airport.common.enums.portrait.UserType;
import com.sundot.airport.common.service.portrait.Indicator;
import com.sundot.airport.system.domain.portrait.IndicatorResult;
import com.sundot.airport.system.domain.portrait.RewardPenaltyStats;
import com.sundot.airport.system.mapper.portrait.RewardPenaltyIndicatorMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 工作奖励指标实现类
 */
@Component
public class WorkRewardsIndicator implements Indicator<Object> {

    @Autowired
    private RewardPenaltyIndicatorMapper rewardPenaltyIndicatorMapper;

    private Object value;

    @Override
    public String getName() {
        return IndicatorType.WORK_REWARDS.getCode();
    }

    @Override
    public Object getValue() {
        return value;
    }

    @Override
    public void calculate(IndicatorCalculateParams params) {
        Long userId = params.getUserId();
        UserType userType = params.getUserType();
        List<Long> userIds = params.getUserIds();
        if (UserType.PERSONAL.equals(userType)) {
            // 个人工作奖励情况
            this.value = rewardPenaltyIndicatorMapper.queryPersonalWorkRewards(userId);
        } else {
            // 组织工作奖励情况统计
            this.value = rewardPenaltyIndicatorMapper.queryOrgWorkRewardsStats(userIds, userType);
        }
    }

    @Override
    public void setResult(BaseModuleIndicatorResult result) {
        if (result instanceof IndicatorResult) {
            IndicatorResult indicatorResult = (IndicatorResult) result;
            if (value instanceof Integer) {
                indicatorResult.setWorkRewards((Integer) value);
            } else if (value instanceof RewardPenaltyStats) {
                indicatorResult.setWorkRewardsStats((RewardPenaltyStats) value);
            }
        }
    }
}